/*  
 * Copyright (c) 2010 Ant Kutschera, maxant
 * 
 * This file is part of the maxant Blog.
 * 
 * maxant Blog is free software: you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maxant Blog is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Lesser GNU General Public License for more details.
 * You should have received a copy of the Lesser GNU General Public License
 * along with maxant Blog.  If not, see <http://www.gnu.org/licenses/>.
 */
package uk.co.maxant.wsdemo;

import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

/**
 * simply logs the SOAP message to the console.
 */
public class MySoapHandler implements SOAPHandler<SOAPMessageContext> {

	@Override
	public void close(MessageContext paramMessageContext) {
		System.out.println();
	}
	@Override
	public Set<QName> getHeaders() {
		return null;
	}
	@Override
	public boolean handleFault(SOAPMessageContext paramC) {
		return true;
	}
	@Override
	public boolean handleMessage(SOAPMessageContext context) {
		
        if (((Boolean) context.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY)).booleanValue()) {
        	System.out.print("OUTBOUND: ");
        }else{
        	System.out.print("INBOUND: ");
        }

        try {
        	SOAPMessage message = context.getMessage();
            message.writeTo(System.out);
        } catch (Exception e) {
            System.err.println("Exception in handler: " + e);
        }
		
		return true;
	}
}
